Imports System.Drawing.Drawing2D

Public Class Form1
    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        Using the_font As New Font("Comic Sans MS", 20)
            DrawFlippedText(e.Graphics, the_font, Brushes.Red, 10, 10, "Flip X", True, False)
            DrawFlippedText(e.Graphics, the_font, Brushes.Green, 10, 100, "Flip Y", False, True)
            DrawFlippedText(e.Graphics, the_font, Brushes.Blue, 100, 100, "Flip XY", True, True)

            ' Optional: Draw boxes around the strings.
            Dim txt_size As SizeF
            txt_size = e.Graphics.MeasureString("Flip X", the_font)
            e.Graphics.DrawRectangle(Pens.Red, 10, 10, txt_size.Width, txt_size.Height)

            txt_size = e.Graphics.MeasureString("Flip Y", the_font)
            e.Graphics.DrawRectangle(Pens.Red, 10, 100, txt_size.Width, txt_size.Height)

            txt_size = e.Graphics.MeasureString("Flip XX", the_font)
            e.Graphics.DrawRectangle(Pens.Red, 100, 100, txt_size.Width, txt_size.Height)
        End Using
    End Sub

    Public Sub DrawFlippedText(ByVal gr As Graphics, ByVal the_font As Font, ByVal the_brush As Brush, ByVal x As Integer, ByVal y As Integer, ByVal txt As String, ByVal flip_x As Boolean, ByVal flip_y As Boolean)
        ' Save the current graphics state.
        Dim state As GraphicsState = gr.Save()

        ' Set up the transformation.
        Dim scale_x As Integer = IIf(flip_x, -1, 1)
        Dim scale_y As Integer = IIf(flip_y, -1, 1)
        gr.ResetTransform()
        gr.ScaleTransform(scale_x, scale_y)

        ' Figure out where to draw.
        Dim txt_size As SizeF = gr.MeasureString(txt, the_font)
        If flip_x Then x = -x - txt_size.Width
        If flip_y Then y = -y - txt_size.Height

        ' Draw.
        gr.DrawString(txt, the_font, the_brush, x, y)

        ' Restore the original graphics state.
        gr.Restore(state)
    End Sub
End Class
